function Grafici_optim_lander(a_orbit,e_orbit,LAN_capture_lander,RAAN_capture_lander,S_vettore_lander, r_capture_lander,i_orbit,p_vector_lander)


a=a_orbit;
e=e_orbit;
OMEGA=RAAN_capture_lander;
OMEGHINO=LAN_capture_lander;
i_p=i_orbit;


OMEGA=OMEGA*pi/180;
OMEGHINO=OMEGHINO*pi/180;

nu_h = 0:pi/100:2*pi;
r= a*(1-e^2)./(1+e*cos(nu_h));

x=r.*cos(nu_h);
y=r.*sin(nu_h);
z=0.*nu_h;
for i=1:size(nu_h,2)
 rPerifocal = [x(i);y(i);z(i)];
 R3_OMEGA = [cos(OMEGA), sin(OMEGA), 0; -sin(OMEGA), cos(OMEGA),0; 0,0,1];
 R1_i= [1, 0, 0; 0,cos(i_p), sin(i_p); 0,-sin(i_p), cos(i_p)];
 R3_OMEGHINO= [cos(OMEGHINO), sin(OMEGHINO), 0; -sin(OMEGHINO), cos(OMEGHINO), 0; 0,0,1];
 R_PG = R3_OMEGHINO*R1_i*R3_OMEGA;  %for perifocal to IJK
 rIJK = R_PG'* rPerifocal;

%inertial system coordinates
 xIJK(i) = rIJK(1); % lungo g1
 yIJK(i) = rIJK(2); % lungo g2
 zIJK(i) = rIJK(3); % lungo g3
 
end 

p_vector_lander=5000*p_vector_lander;
p_vector_lander=[linspace(0,p_vector_lander(1),2);linspace(0,p_vector_lander(2),2);linspace(0,p_vector_lander(3),2)];
r_capture_lander=[linspace(0,r_capture_lander(1),2);linspace(0,r_capture_lander(2),2);linspace(0,r_capture_lander(3),2)];
S_vettore_lander=5000*S_vettore_lander;
S_vettore_lander=[linspace(0,S_vettore_lander(1),2);linspace(0,S_vettore_lander(2),2);linspace(0,S_vettore_lander(3),2)];


figure(4)
title('Lander Optimized Trajectory')
hold on
axis([-a*2 a*2 -a*2 a*2 -2*a 2*a])
view(45,45)
plot3(0,0,0,'*k','HandleVisibility','off')
%plot3(p_vector_lander(1,:),p_vector_lander(2,:),p_vector_lander(3,:), '-c', 'linewidth',3,'HandleVisibility','off')
plot3(r_capture_lander(1,:),r_capture_lander(2,:),r_capture_lander(3,:),'-k','linewidth',2.5,'HandleVisibility','off')
%plot3(S_vettore_lander(1,:),S_vettore_lander(2,:),S_vettore_lander(3,:), '-c', 'linewidth',3,'HandleVisibility','off')
plot3(xIJK,yIJK,zIJK,'-b', 'linewidth', 2)
xlabel('I [Km]')
ylabel('J [Km]')
zlabel('K [Km]')
grid

end 