clc
clear all
i=1;

global a_orbit i_orbit delta_t Perturbation1 Perturbation2
global ra_capture ra_escape dec_capture dec_escape mu C3_c C3_e C3_c_lander ra_capture_lander dec_capture_lander
global M_TOTAL_orbiter M_TOTAL_lander
global  mi_ritorno_orbiter mu_arrivo_orbiter 
global DV_CAPTURE_orbiter DV_ESCAPE_orbiter 
global ms_arrivo_orbiter mp_arrivo_orbiter mp_ritorno_orbiter ms_ritorno_orbiter

global mu_arrivo_lander mi_ascesa_lander mi_discesa_lander mu_discesa_lander
global DV_CAPTURE_lander deltav_ascesa_lander deltav_discesa_lander
global mp_ascesa_lander ms_ascesa_lander mp_discesa_lander ms_discesa_lander mp_arrivo_lander ms_arrivo_lander

%initial data
a_orbit=20448; % semi-major axis[Km]
i_deg=40;     %p.o inclination
rp_min=3389.5+100; %minimum limit
e_max=1-rp_min/a_orbit;


%Orbiter
alpha_c=113.8; %capture right ascension
delta_c=-1.7; %capture declination
C3_c=2.92^2; %capture energy level [Km^2/s^2]
alpha_e=-53.5; %escape right ascension
delta_e=5.3; %escape declination
C3_e=2.47^2; %escape energy level [Km^2/s^2]

%lander
alpha_c_lander=94; %capture right ascension
delta_c_lander=18; %capture declination
C3_c_lander=2.701^2; %capture energy level [Km^2/s^2]

%Date
JD_capture_orbiter=julianday(7, 27, 2042);
JD_escape_orbiter=julianday(7, 31, 2043);
delta_t=(JD_escape_orbiter-JD_capture_orbiter); %giorni
JD_capture_lander=julianday(7, 9, 2040);


%degree to radiant right ascension and declination
ra_capture=alpha_c*pi/180;
ra_escape=alpha_e*pi/180;
dec_capture=delta_c*pi/180;
dec_escape=delta_e*pi/180;
ra_capture_lander=alpha_c_lander*pi/180;
dec_capture_lander=delta_c_lander*pi/180;

ra_capture=pi-ra_capture;       % Right ascension capture hyperbola [rad]
dec_capture=-dec_capture;       % Declination capture hyperbola [rad]
ra_capture_lander=pi-ra_capture_lander;       % Right ascension capture hyperbola [rad]
dec_capture_lander=-dec_capture_lander;       % Declination capture hyperbola [rad]
  

i_orbit=i_deg*pi/180;
mu=42828;  %standard gravitational parameter



LB=[0 0 0 0 0 0 0 0 0]*pi/180;
UB=[360 360 360 360 360 360 360 e_max*180/pi  e_max*180/pi]*pi/180;
options = optimoptions('ga','SelectionFcn',@selectiontournament,'EliteCount',10 ,...
        'CrossoverFraction',0.2,'PlotFcn',{@gaplotbestf,@gaplotmaxconstr},'Display',...
        'iter','InitialPopulationRange', [0;2*pi],'MigrationDirection', 'both' );

toll=1e-2;
diff=1;
Res_test=10;

%[optimal_parameters, DELTA_V_MIN, val,output,population,scores]=ga(@mission4_optim_dv,9,[],[],[],[],LB,UB,[],options);


[optimal_parameters, M_TOTAL_MIN, val,output,population,scores]=ga(@mission4_optim_mass,9,[],[],[],[],LB,UB,[],options);
opt_capture=optimal_parameters*180/pi;
% Results

LAN_capture_orbiter(i)=opt_capture(1);
RAAN_capture_orbiter(i)=opt_capture(2);
INJECTION_capture_orbiter(i)=opt_capture(3);
INJECTION_escape_orbiter(i)=opt_capture(4);
LAN_capture_lander(i)=opt_capture(5);
RAAN_capture_lander(i)=opt_capture(6);
INJECTION_capture_lander(i)=opt_capture(7);
ECCENTRICITY_orbiter(i)=optimal_parameters(8);
ECCENTRICITY_lander(i)=optimal_parameters(9);
M_TOTAL_optim(i)=M_TOTAL_MIN;
%DELTA_V_OPTIM(i)=DELTA_V_MIN;

DV_total=DV_CAPTURE_lander+DV_CAPTURE_orbiter+DV_ESCAPE_orbiter;  %escluse ascesa e discesa
DV_TOTAL=DV_total+deltav_ascesa_lander+deltav_discesa_lander;
mp_TOTAL_lander=mp_arrivo_lander+mp_discesa_lander+mp_ascesa_lander;
mp_TOTAL_orbiter=mp_arrivo_orbiter+mp_ritorno_orbiter;
mp_TOTAL=mp_TOTAL_orbiter+mp_TOTAL_lander;


%% PARAMETRI ORBITALI CATTURA ORBITER

H_po_c_orbiter=cross(r_capture_orbiter, V_capture_orbiter);
i_po_orbiter=acos(H_po_c_orbiter(3)/norm(H_po_c_orbiter));
n_po_c_orbiter=cross([0;0;1],H_po_c_orbiter)/norm(H_po_c_orbiter);
if n_po_c_orbiter(2)>=0
    RAAN_po_c_orbiter=acos(n_po_c_orbiter(1)/norm(n_po_c_orbiter));
else
    RAAN_po_c_orbiter=2*pi-acos(n_po_c_orbiter(1)/norm(n_po_c_orbiter));
end
e_po_c_orbiter=cross(V_capture_orbiter,H_po_c_orbiter)/mu-r_capture_orbiter/norm(r_capture_orbiter);

if e_po_c_orbiter(3)>=0
    AP_capt_c_orbiter=acos((n_po_c_orbiter'*e_po_c_orbiter)/(norm(n_po_c_orbiter)*norm(e_po_c_orbiter)));
else
    AP_capt_c_orbiter=2*pi-acos((n_po_c_orbiter'*e_po_c_orbiter)/(norm(n_po_c_orbiter)*norm(e_po_c_orbiter)));
end

%% PARAMETRI ORBITALI CATTURA LANDER

H_po_c_lander=cross(r_capture_lander, V_capture_lander);
i_po_lander=acos(H_po_c_lander(3)/norm(H_po_c_lander));
n_po_c_lander=cross([0;0;1],H_po_c_lander)/norm(H_po_c_lander);
if n_po_c_lander(2)>=0
    RAAN_po_c_lander=acos(n_po_c_lander(1)/norm(n_po_c_lander));
else
    RAAN_po_c_lander=2*pi-acos(n_po_c_lander(1)/norm(n_po_c_lander));
end
e_po_c_lander=cross(V_capture_lander,H_po_c_lander)/mu-r_capture_lander/norm(r_capture_lander);

if e_po_c_lander(3)>=0
    AP_capt_c_lander=acos((n_po_c_lander'*e_po_c_lander)/(norm(n_po_c_lander)*norm(e_po_c_lander)));
else
    AP_capt_c_lander=2*pi-acos((n_po_c_lander'*e_po_c_lander)/(norm(n_po_c_lander)*norm(e_po_c_lander)));
end
%% PARAMETRI ORBITALI ESCAPE

H_po_e=cross(r_escape_orbiter, V_escape_orbiter);
i_po_e=acos(H_po_e(3)/norm(H_po_e));
n_po_e=cross([0;0;1],H_po_e)/norm(H_po_e);
if n_po_e(2)>=0
    RAAN_po_e=acos(n_po_e(1)/norm(n_po_e));
else
    RAAN_po_e=2*pi-acos(n_po_e(1)/norm(n_po_e));
end
e_po_e=cross(V_escape_orbiter,H_po_e)/mu-r_escape_orbiter/norm(r_escape_orbiter);

if e_po_e(3)>=0
    AP_capt_e=acos((n_po_e'*e_po_e)/(norm(n_po_e)*norm(e_po_e)));
else
    AP_capt_e=2*pi-acos((n_po_e'*e_po_e)/(norm(n_po_e)*norm(e_po_e)));
end

%% PARAMETRI ORBITALI IPERBOLE CATTURA ORBITER
H_hyp_c_orbiter=cross(r_capture_orbiter, V_h_capture_orbiter);
i_hyp_c_orbiter=acos(H_hyp_c_orbiter(3)/norm(H_hyp_c_orbiter));
n_hyp_c_orbiter=cross([0;0;1],H_hyp_c_orbiter)/norm(H_hyp_c_orbiter);
if n_hyp_c_orbiter(2)>=0
    RAAN_hyp_c_orbiter=acos(n_hyp_c_orbiter(1)/norm(n_hyp_c_orbiter));
else
    RAAN_hyp_c_orbiter=2*pi-acos(n_hyp_c_orbiter(1)/norm(n_hyp_c_orbiter));
end
e_hyp_c_orbiter=cross(V_h_capture_orbiter,H_hyp_c_orbiter)/mu-r_capture_orbiter/norm(r_capture_orbiter);
if e_hyp_c_orbiter(3)>=0
    AP_hyp_c_orbiter=acos((n_hyp_c_orbiter'*e_hyp_c_orbiter)/(norm(n_hyp_c_orbiter)*norm(e_hyp_c_orbiter)));
else
    AP_hyp_c_orbiter=2*pi-acos((n_hyp_c_orbiter'*e_hyp_c_orbiter)/(norm(n_hyp_c_orbiter)*norm(e_hyp_c_orbiter)));
end

%% PARAMETRI ORBITALI IPERBOLE CATTURA LANDER
H_hyp_c_lander=cross(r_capture_lander, V_h_capture_lander);
i_hyp_c_lander=acos(H_hyp_c_lander(3)/norm(H_hyp_c_lander));
n_hyp_c_lander=cross([0;0;1],H_hyp_c_lander)/norm(H_hyp_c_lander);
if n_hyp_c_lander(2)>=0
    RAAN_hyp_c_lander=acos(n_hyp_c_lander(1)/norm(n_hyp_c_lander));
else
    RAAN_hyp_c_lander=2*pi-acos(n_hyp_c_lander(1)/norm(n_hyp_c_lander));
end
e_hyp_c_lander=cross(V_h_capture_lander,H_hyp_c_lander)/mu-r_capture_lander/norm(r_capture_lander);
if e_hyp_c_lander(3)>=0
    AP_hyp_c_lander=acos((n_hyp_c_lander'*e_hyp_c_lander)/(norm(n_hyp_c_lander)*norm(e_hyp_c_lander)));
else
    AP_hyp_c_lander=2*pi-acos((n_hyp_c_lander'*e_hyp_c_lander)/(norm(n_hyp_c_lander)*norm(e_hyp_c_lander)));
end

%% PARAMETRI ORBITALI IPERBOLE FUGA
H_hyp_e=cross(r_escape_orbiter, V_h_escape_orbiter);
i_hyp_e=acos(H_hyp_e(3)/norm(H_hyp_e));
n_hyp_e=cross([0;0;1],H_hyp_e)/norm(H_hyp_e);
if n_hyp_e(2)>=0
    RAAN_hyp_e=acos(n_hyp_e(1)/norm(n_hyp_e));
else
    RAAN_hyp_e=2*pi-acos(n_hyp_e(1)/norm(n_hyp_e));
end
e_hyp_e=cross(V_h_escape_orbiter,H_hyp_e)/mu-r_escape_orbiter/norm(r_escape_orbiter);
if e_hyp_e(3)>=0
    AP_hyp_e=acos((n_hyp_e'*e_hyp_e)/(norm(n_hyp_e)*norm(e_hyp_e)));
else
    AP_hyp_e=2*pi-acos((n_hyp_e'*e_hyp_e)/(norm(n_hyp_e)*norm(e_hyp_e)));
end

% %% PARAMETRI ORBITALI SECONDA IPERBOLE CATTURA
% H_hyp_c_2=cross(r_capture, V_h_capture_2);
% i_hyp_c_2=acos(H_hyp_c_2(3)/norm(H_hyp_c_2));
% n_hyp_c_2=cross([0;0;1],H_hyp_c_2)/norm(H_hyp_c_2);
% if n_hyp_c_2(2)>=0
%     RAAN_hyp_c_2=acos(n_hyp_c_2(1)/norm(n_hyp_c_2));
% else
%     RAAN_hyp_c_2=2*pi-acos(n_hyp_c_2(1)/norm(n_hyp_c_2));
% end
% e_hyp_c_2=cross(V_h_capture_2,H_hyp_c_2)/mu-r_capture/norm(r_capture);
% if e_hyp_c_2(3)>=0
%     AP_hyp_c_2=acos((n_hyp_c'*e_hyp_c_2)/(norm(n_hyp_c_2)*norm(e_hyp_c_2)));
% else
%     AP_hyp_c_2=2*pi-acos((n_hyp_c_2'*e_hyp_c_2)/(norm(n_hyp_c_2)*norm(e_hyp_c_2)));
% end
% 
% %% PARAMETRI ORBITALI SECONDA IPERBOLE FUGA
% H_hyp_e_2=cross(r_escape, V_h_escape_2);
% i_hyp_e_2=acos(H_hyp_e_2(3)/norm(H_hyp_e_2));
% n_hyp_e_2=cross([0;0;1],H_hyp_e_2)/norm(H_hyp_e_2);
% if n_hyp_e_2(2)>=0
%     RAAN_hyp_e_2=acos(n_hyp_e_2(1)/norm(n_hyp_e_2));
% else
%     RAAN_hyp_e_2=2*pi-acos(n_hyp_e_2(1)/norm(n_hyp_e_2));
% end
% e_hyp_e_2=cross(V_h_escape_2,H_hyp_e_2)/mu-r_escape/norm(r_escape);
% if e_hyp_e_2(3)>=0
%     AP_hyp_e_2=acos((n_hyp_e_2'*e_hyp_e_2)/(norm(n_hyp_e_2)*norm(e_hyp_e_2)));
% else
%     AP_hyp_e_2=2*pi-acos((n_hyp_e_2'*e_hyp_e_2)/(norm(n_hyp_e_2)*norm(e_hyp_e_2)));
% end
%% PLOT
%Mars sphere
r=3389.5; %Mars radius
[Xs,Ys,Zs]=sphere(20);
rx=r*Xs;
ry=r*Ys;
rz=r*Zs;

%missione orbiter
Grafici_optim_orbiter(a_orbit, ECCENTRICITY_orbiter,LAN_capture_orbiter,RAAN_capture_orbiter,S_vettore_orbiter, S_vettore_e_orbiter, r_capture_orbiter, r_escape_orbiter,i_orbit,p_vector_orbiter,p_escape_orbiter)
hold on 
stampa_iperbole_cattura_orbiter(a_h_capture_orbiter,e_h_capture_orbiter,AP_hyp_c_orbiter,RAAN_hyp_c_orbiter,i_hyp_c_orbiter,phi_capture_orbiter)
stampa_iperbole_escape(a_h_escape_orbiter,e_h_escape_orbiter,AP_hyp_e,RAAN_hyp_e,i_hyp_e,phi_escape_orbiter)
hold on
%legend('Parking Orbit','Capture Hyperbola','Escape Hyperbola')
surf(rx,ry,rz, 'HandleVisibility','off')   %se si vuole trasparenza usare 'FaceAlpha',.1
%hold off

%la seguente parte è da attivare solo se c'è perturbazione in modo da
%vedere l'orbita perturbata nella condizione finale
t=delta_t*86400;
RAAN_escape=optimal_parameters(2)+Perturbation1*t;
LAN_escape=optimal_parameters(1)+Perturbation2*t;
stampa_orbita_perturbata(a_orbit,ECCENTRICITY_orbiter,LAN_escape,RAAN_escape,i_orbit)
hold on
legend('Parking Orbit - Capture Condition','Capture Hyperbola','Escape Hyperbola','Parking Orbit - Escape Condition')  %da attivare se perturbato
hold off


%missione lander
Grafici_optim_lander(a_orbit, ECCENTRICITY_lander,LAN_capture_lander,RAAN_capture_lander,S_vettore_lander, r_capture_lander,i_orbit,p_vector_lander)
hold on
stampa_iperbole_cattura_lander(a_h_capture_lander,e_h_capture_lander,AP_hyp_c_lander,RAAN_hyp_c_lander,i_hyp_c_lander,phi_capture_lander)
legend('Parking Orbit','Capture Hyperbola')
hold on
surf(rx,ry,rz, 'HandleVisibility','off')   %se si vuole trasparenza usare 'FaceAlpha',.1
hold off

